
// ******************************************************************  TEST MAQUETTE TP SARI  ********************************************************************************
// ***************************************************************  ASSERVISSEMENT TEMPERATURE  ******************************************************************************
//
// Programme de caracterisation selon echelon déterminé par SW1 
//
// M.Leyney
// 19/11/2014
// 
// ***********************************************************************************************************************************************************************


#define FIRMWARE_MAJOR 02        
#define FIRMWARE_MINOR 00  
#if defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)
#define DEFAULTBAUDRATE 9600    // Defines The Default Serial Baud Rate (This must match the baud rate specifid in LabVIEW)
#else
#define DEFAULTBAUDRATE 115200
#endif
#define MODE_DEFAULT 0            // Defines Arduino Modes (Currently Not Used)
#define COMMANDLENGTH 15          // Defines The Number Of Bytes In A Single LabVIEW Command (This must match the packet size specifid in LabVIEW)

#define COMMANDE 60   

//Declarations Communication
unsigned char currentCommand[COMMANDLENGTH];
int currentMode;

//Declarations Entrées/Sorties + périphériques
int ledR  =  8;    //LED1 sur pin DIG8
int ledV  =  3;    //LED2 sur pin DIG3
int SW1   =  6;    //SW1 sur pin DIG6
int LM35_in     =    0;    
int PWM_Chauffage    =    9;
const float coef_LM35    =    0.14576;    //10mV/deg + AOP (x3.35)

unsigned long time;

int etat_cons,cons,val;
float degre;
unsigned char degre_entiere,degre_decimale;



// syncLV : Synchronizes with LabVIEW and sends info about the board and firmware (Unimplemented)
void syncLV();

//setMode : Sets the mode of the Arduino (Reserved For Future Use -  Input:  Int - Mode
void setMode(int mode);

//checkForCommand : Checks for new commands from LabVIEW and processes them if any exists.
//  Output: 1 - Command received and processed
//          0 - No new command
int checkForCommand(void);

//processCommand: Processes a given command
//  Input:  command of COMMANDLENGTH bytes
//  Output: 1 - Command received and processed
//          0 - No new command
void processCommand(unsigned char command[]);

//checksum_Compute:  Compute Packet Checksum
//Input:  Command Packet
//Output: Char Checksum Value
unsigned char checksum_Compute(unsigned char command[]);

//checksum_Test :  Compute Packet Checksum And Test Against Included Checksum
// Input:  Command Packet
// Output: 0 If Checksums Are Equal, Else 1
int checksum_Test(unsigned char command[]);


/**********************************************************/
void setup() {
 // int val;
 // byte b;

  pinMode(ledR, OUTPUT);
  pinMode(ledV, OUTPUT);
  pinMode(SW1, INPUT);

  pinMode(PWM_Chauffage, OUTPUT);

  //Wire.begin();   // start Wire library as I2C-Bus Master
  //Serial.begin(9600);

  //initialisation E/S
  digitalWrite(ledV, LOW);
  digitalWrite(ledR, LOW);
  analogWrite(PWM_Chauffage,0);

 // Initialize Serial Port With The Default Baud Rate
  syncLV();


/*  
  //Intro
  Serial.println("*** TEST CARACTERISATION TEMPERATURE ***");
  Serial.print("Positionner SW1 sur ON : ");
  delay(500);
  do{
    b++;
    if(b % 2){
      digitalWrite(ledR, LOW);
    }
    else{
      digitalWrite(ledR, HIGH);
    }
    val = digitalRead(SW1);
    delay(200);
  }
  while(val == LOW);
  Serial.println("OK");
  Serial.print("Positionner SW1 sur OFF : ");    
  delay(500);
  do{
    b++;
    if(b % 2){
      digitalWrite(ledR, LOW);
    }
    else{
      digitalWrite(ledR, HIGH);
    }
    val = digitalRead(SW1);
    delay(200);
  }
  while(val == HIGH);
  Serial.println("OK");
  digitalWrite(ledR, LOW);
  digitalWrite(ledV, HIGH);
  Serial.println("Demarrage du test...   Arret par RESET");
  delay(3000);
  */

}

/**********************************************************/
void loop() {


   // Check for commands from LabVIEW and process them.   
 
  checkForCommand();

  //test SW1 pour mise a jour consigne de chauffe
//  val = digitalRead(SW1);


  if(etat_cons == 0){
    cons = 0; 
    digitalWrite(ledR, LOW);
  }
  else{
    cons = COMMANDE;
    digitalWrite(ledR, HIGH);
  }
  analogWrite(PWM_Chauffage,cons);
  
  //mesure temperature 
  val = analogRead(LM35_in);         
  degre = coef_LM35 * (float)val;
  degre_entiere=(int)degre;
  degre_decimale=int((degre-degre_entiere)*100);

  
/*  //affichage sur console
  time = millis();
  Serial.print(time);  //temps
  Serial.print(",");
  Serial.print(cons);  //consigne echelon PWM (0 à 255)
  Serial.print(",");    
  Serial.println(degre);  //temperature mesurée    
*/

    //echantillonnage
  delay(50);        //boucle totale environ 50ms

}

// Sets the mode of the Arduino (Reserved For Future Use)
void setMode(int mode)
{
  currentMode = mode;
}

// Checks for new commands from LabVIEW and processes them if any exists.
int checkForCommand(void)
{  

  int bufferBytes = Serial.available();

  if(bufferBytes >= COMMANDLENGTH) 
  {
    // New Command Ready, Process It  
    // Build Command From Serial Buffer
    for(int i=0; i<COMMANDLENGTH; i++)
    {
      currentCommand[i] = Serial.read();       
    }     
    processCommand(currentCommand);     
    return 1;
  }
  else
  {
    return 0; 
  }
}

// Processes a given command
void processCommand(unsigned char command[])
{  
  // Determine Command
  if(command[0] == 0xFF && checksum_Test(command) == 0)
  {
    switch(command[1])
    {    
    /*********************************************************************************
    ** LIFA Maintenance Commands
    *********************************************************************************/
    case 0x00:     // Sync Packet
      Serial.print("sync");
      Serial.flush();        
      break;
    case 0x01:    // Flush Serial Buffer  
      Serial.flush();
      break;
      
    /*********************************************************************************
    ** Low Level - Echange de données
    *********************************************************************************/
    case 0x02:    // Ecriture de valeurs 
      etat_cons=command[2];
      Serial.write('0');
      break;


      
    case 0x03:    // Lecture de valeurs

     Serial.write(degre_entiere);
     Serial.write(degre_decimale);
     Serial.write(cons);
      /*retVal = 0x0000;
      for(int i=0; i <=13; i++)
      {
        if(digitalRead(i))
        {
          retVal += (1<<i);
        } 
      }
      Serial.write( (retVal & 0xFF));
      Serial.write( (retVal >> 8));    }=*/
      break;
  
    }
  }
}

// Synchronizes with LabVIEW and sends info about the board and firmware (Unimplemented)
void syncLV()
{
  Serial.begin(DEFAULTBAUDRATE); 
  Serial.flush();
}





// Compute Packet Checksum
unsigned char checksum_Compute(unsigned char command[])
{
  unsigned char checksum=0;
  for (int i=0; i<(COMMANDLENGTH-1); i++)
  {
    checksum += command[i]; 
  }
  return checksum;
}





// Compute Packet Checksum And Test Against Included Checksum
int checksum_Test(unsigned char command[])
{
  unsigned char checksum = checksum_Compute(command);
  if(checksum == command[COMMANDLENGTH-1])
  {
    return 0; 
  }
  else
  {
    return 1;
  }
}
   
